package extensions;

import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.LRUMap;
import dareka.common.Logger;
import dareka.common.NullOutputStream;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Processor;
import dareka.processor.Resource;
import dareka.processor.StringResource;
import dareka.processor.SwfConvertResource;
import dareka.processor.impl.Cache;

/* swfConvertɃ_CNg

擾URLpath擪/swfConverttƁAswfConvertwrapĕԂ܂B
wrapper璼URLĂ炤̂xXgǁARequestHeadertB^
ȉ̂悤ɏĂ삷͂B

[RequestHeader]
Name = swfConvertRedirector
URL = www\.dummy\.com
Match<
(http://[^/]+\.(?:nico|smile)video\.jp)(/smile\?s=\d+\.\d+)$
>
Replace<
$1/swfConvert$2
>

SWFwb_擾API:

/swfConvert/swfHeader?<id> ɃANZXCSV`SWFwb_擾o܂B
ȂOK signature,version,length,width,height,fps,countAsȂNGԂ܂B

肭삷悤ȂwrapperpbP[WɓĖč\܂B

ύX:

rev1 (vt̂ōĂ݂)
rev2 SWFwb_擾APIǉ(NicoCache_nl (9).12 +100914mod Kvł)

*/
public class swfConvertRedirector extends SwfConvertResource
		implements Extension2, Processor {
	
	// Extensioño[W
	public String getVersionString() {
		return "swfConvertRedirector rev2";
	}
	
	// ExtensionNicoCache_nl{̂ɓo^
	public void registerExtensions(ExtensionManager mgr) {
		// Kvȍŝ݃RgO
		mgr.registerProcessor(this);      // ProcessorƂēo^
		//mgr.registerRewriter(this);       // RewriterƂēo^
		//mgr.registerRequestFilter(this);  // RequestFilterƂēo^
	}
	
	// Processor Interface
	private static final String[] PROCESSOR_SUPPORTED_METHODS = new String[] { "GET" };
	private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"^(http://[^/]+\\.(?:nico|smile)video\\.jp)/swfConvert(/.*)$");
	private static final Pattern PATH_SMILE_PATTERN = Pattern.compile(
			"^/smile\\?s=(\\d+)\\.\\d+$");
	private static final Pattern PATH_SWFHEADER_PATTERN = Pattern.compile(
			"^/swfHeader\\?(?:nm)?(\\d+)$");
	
	public String[] getSupportedMethods() {
		return PROCESSOR_SUPPORTED_METHODS;
	}
	
	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}
	
	public String getSupportedURLAsString() {
		return null;
	}
	
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		Matcher m = PROCESSOR_SUPPORTED_PATTERN.matcher(requestHeader.getURI());
		if (!m.matches()) {
			throw new IOException("it must not happen...");
		}
		String base = m.group(1), path = m.group(2);
		if ((m = PATH_SMILE_PATTERN.matcher(path)).matches()) {
			Cache swfCache = new Cache("nm".concat(m.group(1)));
			String url;
			if (swfCache.exists()) {
				url = swfCache.getURLString();
			} else {
				url = base + path + "as3";
			}
			Logger.info("swfConvertRedirector: " + url);
			SwfConvertResource r = createSWF(url, m.group(1));
			if(url.startsWith("http:")) r.setProxyMyself();
			return r;
		} else if ((m = PATH_SWFHEADER_PATTERN.matcher(path)).matches()) {
			String csv = getHeader(m.group(1));
			if (csv == null) {
				Cache swfCache = new Cache("nm".concat(m.group(1)));
				if (swfCache.exists()) {
					SwfConvertResource r = createSWF(swfCache.getURLString(), m.group(1));
					r.transferTo(null, new NullOutputStream(), requestHeader, null);
					csv = getHeader(m.group(1));
				}
			}
			return new StringResource(csv != null ? "OK ".concat(csv) : "NG");
		}
		return StringResource.getNotFound();
	}
	
	private String getHeader(String id) {
		synchronized (swfHeaders) {
			return swfHeaders.get(new Integer(id));
		}
	}
	
	private SwfConvertResource createSWF(String url, String id) throws IOException {
		swfConvertRedirector r = new swfConvertRedirector(url);
		r.id = new Integer(id);
		r.setAS3(false);
		r.setResponseHeader(HttpHeader.CONTENT_TYPE, "video/flv");
		return r;
	}
	
	private static final String EXTENSION_RESOURCE = 
		"http://localhost:" + System.getProperty("listenPort", "8080") + "/swfConvertRedirector";
	private static final LRUMap<Integer, String> swfHeaders = new LRUMap<Integer, String>();
	private Integer id;
	
	public swfConvertRedirector() throws IOException {
		this(EXTENSION_RESOURCE);
	}
	
	public swfConvertRedirector(String resource) throws IOException {
		super(resource);
	}
	
	@Override
	protected void appendHeader(InputStream in) throws IOException {
		super.appendHeader(in);
		if (swfHeaderInfo != null) {
			synchronized (swfHeaders) {
				swfHeaders.put(this.id, swfHeaderInfo);
			}
		}
	}
}
